# MaxAxe (Throw Things)

## Throw Axes, Knives, Maces, Swords, Flaming Torches, Stones, Shields & Tankards. Stack throwing weapons.

- Ever wonder why a Viking's axe (of all things) wouldn't be a weapon of choice? And why you couldn't throw them?
- MaxAxe adds throwing attacks to Axes, Clubs, Torches, Swords, Knives, Maces, Shields and Tankards
- Adds a strong secondary melee attack for Axes and Spears.
- Throw your Shield! Unsling your round shield and send it spinning at your enemy like Cap.
- Throw stones! Whack a Greyling, annoy a Troll, send feathers flying, be a Hobbit.
- Throw tankards! Toast your friends, throw back a cold one, then throw your mug.
- Axe secondary attacks now put it on par with other weapons with strong secondary attacks, like maces and swords.
- Toggle between melee and throwing attacks with a key press.
- Optionally stack throwable weapons; up to 3 Axes, Clubs or Maces, a 'quiver' of 5 Spears, and a 'sheath' of 10 Knives per slot. (see Caution below)
- Has a weapon 'finder' to help locate thrown weapons.
- MaxAxe can automatically equip a backup weapon so you're never fumbling to find another weapon in combat.

## New
- 0.1.9 Added throwing round shields. Hurl your shield and send it spinning. Overhand or underhand.
- 0.1.9 Added configuration for throwing Swords.
- 0.1.9 Added throwing Tankards.
- 0.1.9 Throw (or change throwing status) while moving.

- 0.1.8 Added throwing and melee Stones! Pick up a stone, equip it, and whack a Greyling.
- 0.1.8	Fixed durablity reset on stacked items
- 0.1.8 Fixed issue with thrown axe corrupting normal axe attack with DualWield

## Configuration

### General

- **MeleeAttack**: If True, uses the melee secondary attack. Toggle in-game using the _ToggleMeleeAttack_ key.
- **ToggleMeleeAttack**: Press this key to toggle in-game between Throw and Melee mode for secondary attacks on enabled one-handed weapons. Default is LeftAlt+B.
- **ThrowOne**: Press this key (even in melee mode) to throw the currently equipped weapon (if throwable). Default is T.
- **ThrowShield**: Press this key to throw your currently equipped round shield. Default is G.
- **EnableAxes**: Set to True to enable secondary melee and throwing attacks for one-handed axes.
- **EnableSpears**: Set to True to enable secondary melee attack for spears.
- **EnableKnives**: Set to True to enable secondary throwing attack for knives.
- **EnableSwords**: Set to True to enable secondary throwing attack for swords.
- **EnableClubs**: Set to True to enable secondary throwing attacks for clubs, including maces, Frostner, torches, stones & tankards.
- **EnableShields**: Set to true to enable hurling your round shield with the _ThrowShield_ key. Your shield must be equipped.
- **UnderhandShield**: Set to True to throw your shield using an underhand throw. Shields must also be enabled. Default is False.
- **WeaponStones**: Set to True to equip and attack with stones. Clubs must also be enabled. Can't be changed in-game.
- **StackableWeapons**: Set to True to allow throwable weapons to stack. See _Stackable Weapons_ below before enabling.
- **AutoMelee**: Set to True to automatically switch to melee mode after weapon is thrown (or to prevent throwing the last weapon in a stack).
- **AutoEquip**: Set to True to automatically equip another weapon after a throw. Will try to find the same weapon in inventory first.
- **TargetAdjustment**: Adjusts the vertical throwing impact point in relation to the target reticle (the +). Default is -7. Valnilla Valheim is 0.
- **WeaponFinder**: Type of 'locator' effect added to thrown weapon to make it easier to find. Can be 'Wishbone', 'Autopick' or 'None'. Default is Wishbone.


### Utility

- **LogLevel**: Controls the level of information in the log.

### In-game reconfiguration

You can use Configuration Manager (or similar) mod to change the configuration without exiting the game. You can force a configuration update from the chat window (press Enter) then type:

	/maxaxe config
   
You can also change most settings using this syntax:

	/maxaxe [setting]=[value] , i.e., /maxaxe enableaxes=true


### Stackable Weapons

**READ BEFORE ENABLING STACKABLE WEAPONS**

If you set _StackableWeapons_ to 'true', one-handed axes, knives, clubs and spears will stack - in both player and chest inventory.

If you have stacked weapons in your player inventory, you will not be able to turn StackableWeapons 'off' in-game.

  Split weapon stacks into individual weapons before you disable _StackableWeapons_ or uninstall MaxAxe 

If you have turned off StackableWeapons outside of the game by modifying the configuration file, but still have stacked weapons in your player inventory _or nearby chests_, MaxAxe will automatically turn _StackableWeapons_ back on, so you don't lose the stacks. Unstack these items before turning off _StackableWeapons_. The log file will contain a warning indicating which weapon stack was found (but not which chest, if the stack is in a chest)

If you have uninstalled MaxAxe and restarted the game but had stacked weapons in chests, you may still be able to re-install MaxAxe and retrieve the stacked weapons. If the stack was in player inventory, you will need to exit the game, re-install MaxAxe, and copy the player backup (yourCharacter.fch.old) to the current character file _before_ restarting the game again.

**Durability** With release 0.1.6 stacks of weapons will have durability applied to each weapon in the stack separately (virtually). The durability bar will decrease on the weapon until it breaks. The broken weapon will be removed from the stack, and placed in a separate slot. The durability bar on the 'next' weapon in the stack will be 'full'. If additional weapons of the same type/level break, they will be stacked with existing broken weapons of the same type/level. **NOTE** _If no slot is available for the broken weapon, it will be dropped (but a weapon finder will be added)_.

When stacking weapons, the following applies:

- You can split stacks, but the split stack will have the same durability as the source stack.
- You cannot merge broken weapons into a stack with durability.
- You cannot merge durable weapons into a broken stack (prevents accidentally 'breaking' good weapons)
- You can merge durable weapons into a stack with different durability, but the merged stack will use the durability of the lesser.
- You can merge broken weapons of the same type/level together.
- If you pick up multiple thrown weapons, the stack will use the durability of the least durable weapon, i.e., the 'current' weapon will be the least durable.

### Compatibility issues & defects

- _StackableWeapons_ is not compatible with Epic Loot. If you turn on stackable weapons with Epic Loot, EpicLoot will not be able to create/drop magical One Handed weapons. Existing weapons will continue to work.
- _StackableWeapons_ may not be compatible with custom one-handed weapon prefabs. Prefabs loaded after weapon stack sizes are adjusted will not stack.
- If you're using DualWield with _StackableWeapons_ and throw your weapon then pick it up, your weapon will be added to the stack and not re-equipped. You'll need to split the stack into two in order to re-equip your off-hand weapon.

- If you find a compatibility issue you can post it on NexusMods. Be sure to include the mod name and version you think may be incompatible.
- If you have a bug please report it on NexusMods. If you do post a bug report, please make sure to include the following:
    - Your version of this mod
    - What you were doing, or attempting to do when it happened
    - If it's repeatable - i.e., can you duplicate it?
    - The exact behavior you observed (or didn't observe)
    - If possible, a capture of the log file with errors (errors always begin with this mod's name)

### Notes

- You cannot upgrade weapons in a stack. Unstack a weapon before upgrading.
- Torches will remain lit for a short time after being thrown. Toss into dark areas for a bit of light!
- The spear secondary melee attack uses a powerful spear 'thrust'. Unfortunately the spear is pointed in the wrong direction(!), so this is done with the spear's butt, and therefore delivers Blunt damage!
- Weapon finders are not persisted between sessions. If you don't pick up a weapon and log off, it will no longer display a finder.
- Stones are not recoverable. Just pick up another one.
- Shields deliver attack damage equivalent to their Block damage, but do not factor in Blocking skill to the damage.
- Thrown (and melee) tankard attacks don't require mead in your inventory.

- Shameless plugs for other mods (mirror on Thunderstore):
    - WolfPack: Control all your tame creatures at once! https://www.nexusmods.com/valheim/mods/1549/
    - RequipMe: Instantly re-equip your best gear from your tombstone! https://www.nexusmods.com/valheim/mods/1615
    - Reely SpecTackleLure: Fishing skill, craftable equipment, fishing aids and deep-sea danger... https://www.nexusmods.com/valheim/mods/1655
    - UnRemove: Restore your destroyed pieces without rebuilding them. https://www.nexusmods.com/valheim/mods/1676
    
- Your comments and feedback are always welcome. Please feel free to post or send a note on NexusMods.